{$mode ObJFPC}
Unit logik;

interface

procedure Zeige_Aktuell;
procedure Zeige_Standard;
procedure Zeige_Analyse(analyse_erlaubt: boolean);
procedure Zeige_Parm;
procedure Setze_Standard;
procedure Setze_Analyse;
procedure Setze_Parm;
procedure Auswerte_Standard;
procedure Auswerte_Analyse;
procedure Auswerte_Parm;
procedure Setze_B0_P0;
procedure Setze_Ergebnis;

var
   akt_buffer, akt_zeilen, akt_verf: integer;
   std_buffer, std_zeilen, std_verf: integer;
   vstd_buffer, vstd_zeilen, vstd_verf: boolean;
   anly_buffer, anly_zeilen, anly_verf: integer;
   vanly_buffer, vanly_zeilen, vanly_verf: boolean;
   parm_buffer, parm_zeilen, parm_verf: integer;
   vparm_buffer, vparm_zeilen, vparm_verf: boolean;
   analysefrei, baumalgo: boolean;
   buffermax, blattmax, dynlaenge: integer;

implementation

procedure Zeige_Aktuell;
begin
   writeln('Aktuell');
   writeln('Verfahren           = ', akt_verf);
   writeln('Puffer              = ', akt_buffer);
   writeln('Laenge(Zeilen)      = ', akt_zeilen);
   writeln;
end;

procedure Zeige_Standard;
begin
   writeln('Standard');
   writeln('Verfahren/Standard  = ', vstd_verf, ' ',   std_verf);
   writeln('Puffer/Standard     = ', vstd_buffer, ' ', std_buffer);
   writeln('Laenge/Standard     = ', vstd_zeilen, ' ', std_zeilen);
   writeln;
end;

procedure Zeige_Analyse(analyse_erlaubt: boolean);
begin
   writeln('Analyse');
   if  analyse_erlaubt <> analysefrei then  begin
      writeln('Analyse frei/alt    = ', analysefrei);
      analysefrei:=analyse_erlaubt;
   end;
   writeln('Analyse frei        = ', analysefrei);
   writeln('Verfahren/Analyse   = ', vanly_verf, ' ',   anly_verf);
   writeln('Puffer/Analyse      = ', vanly_buffer, ' ', anly_buffer);
   writeln('Laenge/Analyse      = ', vanly_zeilen, ' ', anly_zeilen);
   writeln;
end;

procedure Zeige_Parm;
begin
   writeln('Parameter');
   writeln('Verfahren/Parameter = ', vparm_verf, ' ',   parm_verf);
   writeln('Puffer/Parameter    = ', vparm_buffer, ' ', parm_buffer);
   writeln('Laenge/Parameter    = ', vparm_zeilen, ' ', parm_zeilen);
   writeln;
end;

procedure Setze_Standard;
begin
   writeln('Setze Standard');
   vstd_verf:=true;       std_verf:=1;
   vstd_buffer:=false;    std_buffer:=2;
   vstd_zeilen:=true;     std_zeilen:=3;
   writeln;
end;

procedure Setze_Analyse;
begin
   writeln('Setze Analyse');
   writeln('Analyse erlaubt     = ', analysefrei);
   if  analysefrei then  begin
      vanly_verf:=true;       anly_verf:=0;
      vanly_buffer:=false;    anly_buffer:=44;
      vanly_zeilen:=true;     anly_zeilen:=10;
   end;
   writeln;
end;

procedure Setze_Parm;
begin
   writeln('Setze Parameter');
   vparm_verf:=false;      parm_verf:=33;
   vparm_buffer:=true;     parm_buffer:=22;
   vparm_zeilen:=true;     parm_zeilen:=0;
   writeln;
end;

procedure Auswerte_Standard;
begin
   writeln('Auswerten, Setzen nach Standard');
   if  vstd_verf       AND (std_verf >= 0)     then akt_verf:=std_verf;
   if  vstd_buffer     AND (std_buffer >= 0)   then akt_buffer:=std_buffer;
   if  vstd_zeilen     AND (std_zeilen > 0)    then akt_zeilen:=std_zeilen;
   writeln;
end;

procedure Auswerte_Analyse;
begin
   writeln('Auswerten, Setzen nach Analyse');
   writeln('Analyse erlaubt     = ', analysefrei);
   if  analysefrei then  begin
      if  vanly_verf      AND (anly_verf >= 0)    then akt_verf:=anly_verf;
      if  vanly_buffer    AND (anly_buffer >= 0)  then akt_buffer:=anly_buffer;
      if  vanly_zeilen    AND (anly_zeilen > 0)   then akt_zeilen:=anly_zeilen;
   end;
   writeln;
end;

procedure Auswerte_Parm;
begin
   writeln('Auswerten, Setzen nach Parameter');
   if  vparm_verf      AND (parm_verf >= 0)    then akt_verf:=parm_verf;
   if  vparm_buffer    AND (parm_buffer >= 0)  then akt_buffer:=parm_buffer;
   if  vparm_zeilen    AND (parm_zeilen > 0)   then akt_zeilen:=parm_zeilen;
   writeln;
end;

procedure Setze_B0_P0;
begin
   writeln('Verfahren/alt       = ', akt_verf);
   writeln('Puffer/alt          = ', akt_buffer);
   if  akt_verf = 0
      then akt_buffer:=0
      else if akt_buffer = 0
              then akt_verf:=0;
   writeln('Verfahren/neu       = ', akt_verf);
   writeln('Puffer/neu          = ', akt_buffer);
   writeln;
end;

procedure Setze_Ergebnis;
begin
   writeln('Ergebnis');
   writeln('Verfahren           = ', akt_verf);
   baumalgo:=akt_verf=1;
   if  baumalgo then blattmax:=akt_buffer
                else buffermax:=akt_buffer;
   if  baumalgo
      then writeln('Blaetter            = ', blattmax)
      else writeln('Puffer              = ', buffermax);
   dynlaenge:=akt_zeilen;
   writeln('Dyn.Laenge(Zeilen)  = ', dynlaenge);
   writeln;
end;

begin
   akt_verf:=-1; akt_buffer:=-1; akt_zeilen:=-1;
   analysefrei:=false; baumalgo:=false;
   buffermax:=0; blattmax:=0; dynlaenge:=5000;
end.
