unit prioparmonline_main;

{$mode ObJFPC}

interface

uses
  LCLIntf, LCLType, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, Spin, LConvEncoding, SpinEx,

  {$IFNDEF Linux} Windows, Messages, {$ENDIF} UTF8, logik;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button_Abfrage: TButton;
    Button_Auswertung: TButton;
    Button_Berechne: TButton;
    Button_Ergebnis: TButton;
    Button_Komplett: TButton;
    Label_Analyse: TLabel;
    Label_Parameter: TLabel;
    Label_Standard_Puffer: TLabel;
    Label_Analyse_frei: TLabel;
    Label_Standard_Zeilen: TLabel;
    Label_Analyse_Verfahren: TLabel;
    Label_Analyse_Puffer: TLabel;
    Label_Analyse_Zeilen: TLabel;
    Label_Parameter_Verfahren: TLabel;
    Label_Parameter_Puffer: TLabel;
    Label_Parameter_Zeilen: TLabel;
    Label_Analyse_Vorhanden: TLabel;
    Label_Parameter_Vorhanden: TLabel;
    Label_Standard_Wert: TLabel;
    Label_Standard_Vorhanden: TLabel;
    Label_Standard_Verfahren: TLabel;
    Label_Standard: TLabel;
    Label_Analyse_Wert: TLabel;
    Label_Parameter_Wert: TLabel;
    Memo_Auswerten: TMemo;

    SpinEdit_Standard_Verfahren: TSpinEdit;
    SpinEdit_Standard_Puffer: TSpinEdit;
    SpinEdit_Standard_Zeilen: TSpinEdit;
    SpinEdit_Analyse_Verfahren: TSpinEdit;
    SpinEdit_Analyse_Puffer: TSpinEdit;
    SpinEdit_Analyse_Zeilen: TSpinEdit;
    SpinEdit_Parameter_Verfahren: TSpinEdit;
    SpinEdit_Parameter_Puffer: TSpinEdit;
    SpinEdit_Parameter_Zeilen: TSpinEdit;
    ToggleBox_Standard_Verfahren: TToggleBox;
    ToggleBox_Standard_Puffer: TToggleBox;
    ToggleBox_Analyse_Frei: TToggleBox;
    ToggleBox_Standard_Zeilen: TToggleBox;
    ToggleBox_Analyse_Verfahren: TToggleBox;
    ToggleBox_Analyse_Puffer: TToggleBox;
    ToggleBox_Analyse_Zeilen: TToggleBox;
    ToggleBox_Parameter_Verfahren: TToggleBox;
    ToggleBox_Parameter_Puffer: TToggleBox;
    ToggleBox_Parameter_Zeilen: TToggleBox;

    procedure Zeige;
    procedure Zeige_Standard;
    procedure Zeige_Parm;
    procedure Zeige_Analyse;
    procedure Auswerten_Standard(ausgabe: boolean);
    procedure Auswerten_Parm(ausgabe: boolean);
    procedure Auswerten_Analyse(ausgabe: boolean);
    procedure Berechne(loeschen: boolean);
    procedure Ergebnis_B0_P0(ausgabe: boolean);
    procedure Ergebnis;
    procedure Scannen_Werte;

    procedure Button_AuswertungClick(Sender: TObject);
    procedure Button_AbfrageClick(Sender: TObject);
    procedure Button_ErgebnisClick(Sender: TObject);
    procedure Button_KomplettClick(Sender: TObject);
    procedure Button_BerechneClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ToggleBox_AnalysefreiChange(Sender: TObject);
    procedure ToggleBox_Standard_VerfahrenChange(Sender: TObject);
    procedure ToggleBox_Standard_ZeilenChange(Sender: TObject);
    procedure ToggleBox_Standard_PufferChange(Sender: TObject);
    procedure ToggleBox_Analyse_VerfahrenChange(Sender: TObject);
    procedure ToggleBox_Analyse_ZeilenChange(Sender: TObject);
    procedure ToggleBox_Analyse_PufferChange(Sender: TObject);
    procedure ToggleBox_Parameter_VerfahrenChange(Sender: TObject);
    procedure ToggleBox_Parameter_ZeilenChange(Sender: TObject);
    procedure ToggleBox_Parameter_PufferChange(Sender: TObject);
    function JaNein(wert:boolean):String;
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

function TForm1.JaNein(wert:boolean):String;
begin
   if wert then JaNein:='Ja' else JaNein:='Nein';
end;

procedure TForm1.Scannen_Werte;
begin
   akt_verf:=-1; akt_buffer:=-1; akt_zeilen:=-1;
   vstd_verf:=ToggleBox_Standard_Verfahren.Checked;
   vstd_buffer:=ToggleBox_Standard_Puffer.Checked;
   vstd_zeilen:=ToggleBox_Standard_Zeilen.Checked;
   vparm_verf:=ToggleBox_Parameter_Verfahren.Checked;
   vparm_buffer:=ToggleBox_Parameter_Puffer.Checked;
   vparm_zeilen:=ToggleBox_Parameter_Zeilen.Checked;
   vanly_verf:=ToggleBox_Analyse_Verfahren.Checked;
   vanly_buffer:=ToggleBox_Analyse_Puffer.Checked;
   vanly_zeilen:=ToggleBox_Analyse_Zeilen.Checked;
   std_verf:=SpinEdit_Standard_Verfahren.Value;
   std_buffer:=SpinEdit_Standard_Puffer.Value;
   std_zeilen:=SpinEdit_Standard_Zeilen.Value;
   anly_verf:=SpinEdit_Analyse_Verfahren.Value;
   anly_buffer:=SpinEdit_Analyse_Puffer.Value;
   anly_zeilen:=SpinEdit_Analyse_Zeilen.Value;
   parm_verf:=SpinEdit_Parameter_Verfahren.Value;
   parm_buffer:=SpinEdit_Parameter_Puffer.Value;
   parm_zeilen:=SpinEdit_Parameter_Zeilen.Value;
   analysefrei:=ToggleBox_Analyse_Frei.Checked;
end;

procedure TForm1.ToggleBox_AnalysefreiChange(Sender: TObject);
begin
   ToggleBox_Analyse_Frei.Caption:=JaNein(ToggleBox_Analyse_Frei.Checked);
end;

procedure TForm1.ToggleBox_Standard_VerfahrenChange(Sender: TObject);
begin
   ToggleBox_Standard_Verfahren.Caption:=JaNein(ToggleBox_Standard_Verfahren.Checked);
   SpinEdit_Standard_Verfahren.Enabled:=ToggleBox_Standard_Verfahren.Checked;
end;

procedure TForm1.ToggleBox_Standard_ZeilenChange(Sender: TObject);
begin
   ToggleBox_Standard_Zeilen.Caption:=JaNein(ToggleBox_Standard_Zeilen.Checked);
   SpinEdit_Standard_Zeilen.Enabled:=ToggleBox_Standard_Zeilen.Checked;
end;

procedure TForm1.ToggleBox_Standard_PufferChange(Sender: TObject);
begin
   ToggleBox_Standard_Puffer.Caption:=JaNein(ToggleBox_Standard_Puffer.Checked);
   SpinEdit_Standard_Puffer.Enabled:=ToggleBox_Standard_Puffer.Checked;
end;

procedure TForm1.ToggleBox_Analyse_VerfahrenChange(Sender: TObject);
begin
   ToggleBox_Analyse_Verfahren.Caption:=JaNein(ToggleBox_Analyse_Verfahren.Checked);
   SpinEdit_Analyse_Verfahren.Enabled:=ToggleBox_Analyse_Verfahren.Checked;
end;

procedure TForm1.ToggleBox_Analyse_ZeilenChange(Sender: TObject);
begin
   ToggleBox_Analyse_Zeilen.Caption:=JaNein(ToggleBox_Analyse_Zeilen.Checked);
   SpinEdit_Analyse_Zeilen.Enabled:=ToggleBox_Analyse_Zeilen.Checked;
end;

procedure TForm1.ToggleBox_Analyse_PufferChange(Sender: TObject);
begin
   ToggleBox_Analyse_Puffer.Caption:=JaNein(ToggleBox_Analyse_Puffer.Checked);
   SpinEdit_Analyse_Puffer.Enabled:=ToggleBox_Analyse_Puffer.Checked;
end;

procedure TForm1.ToggleBox_Parameter_VerfahrenChange(Sender: TObject);
begin
   ToggleBox_Parameter_Verfahren.Caption:=JaNein(ToggleBox_Parameter_Verfahren.Checked);
   SpinEdit_Parameter_Verfahren.Enabled:=ToggleBox_Parameter_Verfahren.Checked;
end;

procedure TForm1.ToggleBox_Parameter_ZeilenChange(Sender: TObject);
begin
   ToggleBox_Parameter_Zeilen.Caption:=JaNein(ToggleBox_Parameter_Zeilen.Checked);
   SpinEdit_Parameter_Zeilen.Enabled:=ToggleBox_Parameter_Zeilen.Checked;
end;

procedure TForm1.ToggleBox_Parameter_PufferChange(Sender: TObject);
begin
   ToggleBox_Parameter_Puffer.Caption:=JaNein(ToggleBox_Parameter_Puffer.Checked);
   SpinEdit_Parameter_Puffer.Enabled:=ToggleBox_Parameter_Puffer.Checked;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   SpinEdit_Standard_Verfahren.MinValue:=0;
   SpinEdit_Standard_Verfahren.MaxValue:=5;
   SpinEdit_Standard_Verfahren.Value:=1;
   SpinEdit_Standard_Verfahren.Enabled:=true;
   SpinEdit_Standard_Zeilen.MinValue:=1;
   SpinEdit_Standard_Zeilen.MaxValue:=1000000;
   SpinEdit_Standard_Zeilen.Value:=3;
   SpinEdit_Standard_Zeilen.Enabled:=true;
   SpinEdit_Standard_Puffer.MinValue:=0;
   SpinEdit_Standard_Puffer.MaxValue:=999;
   SpinEdit_Standard_Puffer.Value:=2;
   SpinEdit_Standard_Puffer.Enabled:=true;
   SpinEdit_Analyse_Verfahren.MinValue:=0;
   SpinEdit_Analyse_Verfahren.MaxValue:=5;
   SpinEdit_Analyse_Zeilen.MinValue:=1;
   SpinEdit_Analyse_Zeilen.MaxValue:=1000000;
   SpinEdit_Analyse_Puffer.MinValue:=0;
   SpinEdit_Analyse_Puffer.MaxValue:=999;
   SpinEdit_Parameter_Verfahren.MinValue:=0;
   SpinEdit_Parameter_Verfahren.MaxValue:=5;
   SpinEdit_Parameter_Zeilen.MinValue:=1;
   SpinEdit_Parameter_Zeilen.MaxValue:=1000000;
   SpinEdit_Parameter_Puffer.MinValue:=0;
   SpinEdit_Parameter_Puffer.MaxValue:=999;
   Scannen_Werte;
end;

procedure TForm1.Button_AbfrageClick(Sender: TObject);
var t:string;
begin
   Scannen_Werte;
   Memo_Auswerten.Clear;
   t:='Standard Verfahren ist ' + ToggleBox_Standard_Verfahren.Caption;
   if ToggleBox_Standard_Verfahren.Checked then t:=t+' : ' + SpinEdit_Standard_Verfahren.Value.toString;
   Memo_Auswerten.Append(t);
   t:='Standard Puffer ist ' + ToggleBox_Standard_Puffer.Caption;
   if ToggleBox_Standard_Puffer.Checked then t:=t+' : ' + SpinEdit_Standard_Puffer.Value.toString;
   Memo_Auswerten.Append(t);
   t:='Standard Zeilen ist ' + ToggleBox_Standard_Zeilen.Caption;
   if ToggleBox_Standard_Zeilen.Checked then t:=t+' : ' + SpinEdit_Standard_Zeilen.Value.toString;
   Memo_Auswerten.Append(t);
   Memo_Auswerten.Append('');
   t:='Analyse Frei ist ' + ToggleBox_Analyse_Frei.Caption;
   Memo_Auswerten.Append(t);
   t:='Analyse Verfahren ist ' + ToggleBox_Analyse_Verfahren.Caption;
   if ToggleBox_Analyse_Verfahren.Checked then t:=t+' : ' + SpinEdit_Analyse_Verfahren.Value.toString;
   Memo_Auswerten.Append(t);
   t:='Analyse Puffer ist ' + ToggleBox_Analyse_Puffer.Caption;
   if ToggleBox_Analyse_Puffer.Checked then t:=t+' : ' + SpinEdit_Analyse_Puffer.Value.toString;
   Memo_Auswerten.Append(t);
   t:='Analyse Zeilen ist ' + ToggleBox_Analyse_Zeilen.Caption;
   if ToggleBox_Analyse_Zeilen.Checked then t:=t+' : ' + SpinEdit_Analyse_Zeilen.Value.toString;
   Memo_Auswerten.Append(t);
   Memo_Auswerten.Append('');
   t:='Parameter Verfahren ist ' + ToggleBox_Parameter_Verfahren.Caption;
   if ToggleBox_Parameter_Verfahren.Checked then t:=t+' : ' + SpinEdit_Parameter_Verfahren.Value.toString;
   Memo_Auswerten.Append(t);
   t:='Parameter Puffer ist ' + ToggleBox_Parameter_Puffer.Caption;
   if ToggleBox_Parameter_Puffer.Checked then t:=t+' : ' + SpinEdit_Parameter_Puffer.Value.toString;
   Memo_Auswerten.Append(t);
   t:='Parameter Zeilen ist ' + ToggleBox_Parameter_Zeilen.Caption;
   if ToggleBox_Parameter_Zeilen.Checked then t:=t+' : ' + SpinEdit_Parameter_Zeilen.Value.toString;
   Memo_Auswerten.Append(t);
end;

procedure TForm1.Zeige;
begin
   Memo_Auswerten.Append('Aktuelles');
   Memo_Auswerten.Append('Verfahren = ' + akt_verf.toString);
   Memo_Auswerten.Append('Puffer    = ' + akt_buffer.toString);
   Memo_Auswerten.Append('Zeilen    = ' + akt_zeilen.toString);
   Memo_Auswerten.Append('');
end;

procedure TForm1.Ergebnis;
begin
   Setze_Ergebnis;
   Memo_Auswerten.Append('Ergebnis');
   Memo_Auswerten.Append('Verfahren = ' + akt_verf.toString);
   if baumalgo
      then Memo_Auswerten.Append('Blaetter  = ' + blattmax.toString)
      else Memo_Auswerten.Append('Puffer    = ' + buffermax.toString);
   Memo_Auswerten.Append('Dyn.Laenge= ' + dynlaenge.toString);
   Memo_Auswerten.Append('');
end;

procedure TForm1.Berechne(loeschen: boolean);
begin
   Setze_Ergebnis;
   if loeschen then Memo_Auswerten.Clear;
   Memo_Auswerten.Append('Berechne');
   Memo_Auswerten.Append('Verfahren = ' + akt_verf.toString);
   if baumalgo
      then Memo_Auswerten.Append('Blaetter  = ' + blattmax.toString)
      else Memo_Auswerten.Append('Puffer    = ' + buffermax.toString);
   Memo_Auswerten.Append('Dyn.Laenge= ' + dynlaenge.toString);
   Memo_Auswerten.Append('');
end;

procedure TForm1.Zeige_Standard;
var t:string;
begin
   Memo_Auswerten.Append('Standard');
   t:='Verfahren/Standard = ' + JaNein(vstd_verf); if vstd_verf then t:=t + ' ' + std_verf.toString;
   Memo_Auswerten.Append(t);
   t:='Puffer/Standard = ' + JaNein(vstd_buffer);  if vstd_buffer then t:=t + ' ' + std_buffer.toString;
   Memo_Auswerten.Append(t);
   t:='Zeilen/Standard = ' + JaNein(vstd_zeilen);  if vstd_zeilen then t:=t + ' ' + std_zeilen.toString;
   Memo_Auswerten.Append(t);
   Memo_Auswerten.Append('');
end;

procedure TForm1.Zeige_Parm;
var t:string;
begin
   Memo_Auswerten.Append('Parameter');
   t:='Verfahren/Parm = ' + JaNein(vparm_verf); if vparm_verf then t:=t + ' ' + parm_verf.toString;
   Memo_Auswerten.Append(t);
   t:='Puffer/Parm = ' + JaNein(vparm_buffer);  if vparm_buffer then t:=t + ' ' + parm_buffer.toString;
   Memo_Auswerten.Append(t);
   t:='Zeilen/Parm = ' + JaNein(vparm_zeilen);  if vparm_zeilen then t:=t + ' ' + parm_zeilen.toString;
   Memo_Auswerten.Append(t);
   Memo_Auswerten.Append('');
end;

procedure TForm1.Zeige_Analyse;
var t:string;
begin
   Memo_Auswerten.Append('Analyse');
   Memo_Auswerten.Append('Analyse frei      = ' + JaNein(analysefrei));
   t:='Verfahren/Analyse = ' + JaNein(vanly_verf); if vanly_verf then t:=t + ' ' + anly_verf.toString;
   Memo_Auswerten.Append(t);
   t:='Puffer/Analyse = ' + JaNein(vanly_buffer);  if vanly_buffer then t:=t + ' ' + anly_buffer.toString;
   Memo_Auswerten.Append(t);
   t:='Zeilen/Analyse = ' + JaNein(vanly_zeilen);  if vanly_zeilen then t:=t + ' ' + anly_zeilen.toString;
   Memo_Auswerten.Append(t);
   Memo_Auswerten.Append('');
end;

procedure TForm1.Auswerten_Analyse(ausgabe: boolean);
begin
   if ausgabe then Memo_Auswerten.Append('Auswerten, Setzen nach Analyse');
   if ausgabe then Memo_Auswerten.Append('Analyse erlaubt =   ' + JaNein(analysefrei));
   Auswerte_Analyse;
   if ausgabe then Memo_Auswerten.Append('');
end;

procedure TForm1.Auswerten_Parm(ausgabe: boolean);
begin
   if ausgabe then Memo_Auswerten.Append('Auswerten, Setzen nach Parameter');
   Auswerte_Parm;
   if ausgabe then Memo_Auswerten.Append('');
end;

procedure TForm1.Auswerten_Standard(ausgabe: boolean);
begin
   if ausgabe then Memo_Auswerten.Append('Auswerten, Setzen nach Standard');
   Auswerte_Standard;
   if ausgabe then Memo_Auswerten.Append('');
end;

procedure TForm1.Ergebnis_B0_P0(ausgabe: boolean);
begin
   if ausgabe then Memo_Auswerten.Append('Verfahren/alt = ' + akt_verf.toString);
   if ausgabe then Memo_Auswerten.Append('Puffer/alt    = ' + akt_buffer.toString);
   Setze_B0_P0;
   if ausgabe then Memo_Auswerten.Append('Verfahren/neu = ' + akt_verf.toString);
   if ausgabe then Memo_Auswerten.Append('Puffer/neu    = ' + akt_buffer.toString);
   if ausgabe then Memo_Auswerten.Append('');
end;

procedure TForm1.Button_AuswertungClick(Sender: TObject);
begin
   Scannen_Werte;
   Memo_Auswerten.Clear;
   Zeige;

   Zeige_Standard;
   Auswerten_Standard(true);
   Zeige;

   Zeige_Analyse;
   Auswerten_Analyse(true);
   Zeige;

   Zeige_Parm;
   Auswerten_Parm(true);
   Zeige;

   Ergebnis_B0_P0(true);

   Ergebnis;
end;

procedure TForm1.Button_ErgebnisClick(Sender: TObject);
begin
   Scannen_Werte;
   Auswerten_Standard(false);
   Auswerten_Analyse(false);
   Auswerten_Parm(false);
   Ergebnis_B0_P0(false);
   Memo_Auswerten.Clear;
   Ergebnis;
end;

procedure TForm1.Button_BerechneClick(Sender: TObject);
begin
   Berechne(false);
   Ergebnis;
end;

procedure TForm1.Button_KomplettClick(Sender: TObject);
begin
   Scannen_Werte;
   Auswerten_Standard(false);
   Auswerten_Analyse(false);
   Auswerten_Parm(false);
   Ergebnis_B0_P0(false);
   Berechne(true);
   Ergebnis;
end;

end.
